      SUBROUTINE FILLINDEX(X,Y,Z,J) ! SUBROUTINE FOR CALCULATING THE 48 SYMERTY POINTS FOR 1/48 SPLINT
      USE halvorinit

      INTEGER        :: X,Y,Z,II,IX,IY,IZ,J(48)

      II=0

      DO IZ=1,-1,-2
          DO IY=1,-1,-2
              DO IX=1,-1,-2
                  II=II+1
                  J(II)=(IX*(X)-(IX+1)/2+MESHNU/2)+(IY*(Y)-(IY+1)/2+MESHNU/2)*MESHNU+(IZ*(Z)-(IZ+1)/2+MESHNU/2)*MESHNU*MESHNU
                  J(II+8)=(IX*(X)-(IX+1)/2+MESHNU/2)+(IY*(Z)-(IY+1)/2+MESHNU/2)*MESHNU+(IZ*(Y)-(IZ+1)/2+MESHNU/2)*MESHNU*MESHNU
                  J(II+16)=(IX*(Z)-(IX+1)/2+MESHNU/2)+(IY*(X)-(IY+1)/2+MESHNU/2)*MESHNU+(IZ*(Y)-(IZ+1)/2+MESHNU/2)*MESHNU*MESHNU
                  J(II+24)=(IX*(Y)-(IX+1)/2+MESHNU/2)+(IY*(X)-(IY+1)/2+MESHNU/2)*MESHNU+(IZ*(Z)-(IZ+1)/2+MESHNU/2)*MESHNU*MESHNU
                  J(II+32)=(IX*(Y)-(IX+1)/2+MESHNU/2)+(IY*(Z)-(IY+1)/2+MESHNU/2)*MESHNU+(IZ*(X)-(IZ+1)/2+MESHNU/2)*MESHNU*MESHNU
                  J(II+40)=(IX*(Z)-(IX+1)/2+MESHNU/2)+(IY*(Y)-(IY+1)/2+MESHNU/2)*MESHNU+(IZ*(X-(IZ+1)/2)+MESHNU/2)*MESHNU*MESHNU
              END DO
          END DO
      END DO

      END SUBROUTINE

      PROGRAM ABINITCONVERTER

      USE halvorinit

      CHARACTER(LEN=12) :: CHA,ABINAMEC,ABINAMEF,ENNAMEA(7)             ! CHA IS A DUMMY CHARACTER, READING STRINGS ONLY TO SKIP SPACES IN THE FILES FROM ABINIT
      REAL(KIND=DBL)    :: REA(14),EADJ(7),EADJ0(7),MSIZE,WAVMAX,ARR    ! ARR IS A DUMMY REAL VARIABLE, READING REAL NUMBER ONLY TO SKIP SPACES IN THE FILES FROM ABINIT
      INTEGER           :: I,L,LI,K,IJ,J(48),N,N1,I1,I2,IC
      INTEGER           :: X,Y,Z

!     INITIALIZING PARAMETERS WITH VALUES STORED ON FILE

      OPEN(50,FILE='ABINIT.INI',ACCESS='DIRECT',FORM='UNFORMATTED',STATUS='OLD',RECL=360)
      READ (50,REC=1) ABINAMEC,ABINAMEF,ENNAMEA,ENNAME,GRNAME,SDNAME
      CLOSE(50)

      WRITE(*,*) ' '
      WRITE(*,*) 'STARTING CONVERSION FROM ABINIT COARSE MESH FILE'
      WRITE(*,*) ' '

      OPEN(1,FILE=ABINAMEC,FORM='FORMATTED')
      READ(1,*) CHA,CHA,CHA,CHA,CHA,CHA,N

      N1=N
      I1=0
      I2=0
      DO WHILE(N1.GT.0)
          I1=I1+1
          I2=I2+I1
          N1=N1-I2
      END DO

!     GAMMA-POINT ADJUSTMENTS AND SCISSORS OPERATOR
      EADJ(1)=-3.76653
      EADJ(2)=-3.76653
      EADJ(3)=-3.76653
!      EADJ(4)=-3.54054     ! Eg=0.211eV 77K
      EADJ(4)=-3.51954     ! Eg=0.265eV 300K
!      EADJ(5)=-3.54054     ! 77K
      EADJ(5)=-3.51954     ! 300K
!      EADJ(6)=-3.54054     ! 77K
      EADJ(6)=-3.51954     ! 300K
!      EADJ(7)=-3.54054     ! 77K
      EADJ(7)=-3.51954     ! 300K

      EADJ0(1)=-0.95357
      EADJ0(2)=0.00000
      EADJ0(3)=0.00000
!      EADJ0(4)=0.21100     ! Eg=0.211eV 77K
      EADJ0(4)=0.26500     ! Eg=0.265eV 300K
!      EADJ0(5)=4.36667     ! 77K
      EADJ0(5)=4.42067     ! 300K
!      EADJ0(6)=5.62544     ! 77K
      EADJ0(6)=5.67944     ! 300K
!      EADJ0(7)=5.62544     ! 77K
      EADJ0(7)=5.67944     ! 300K

      MESHNU=2*I1
      BFRAC=1.
      WAVMAX=2*BFRAC*PI/A0
      MSIZE=2*WAVMAX/(MESHNU-1)
      FINE=.TRUE.

      DO I=1,MSH
          OPEN(10+I,FILE=ENNAMEA(I),ACCESS='DIRECT',FORM='UNFORMATTED',RECL=8,STATUS='UNKNOWN')
          WRITE(10+I,REC=1) MESHNU
          WRITE(10+I,REC=2) WAVMAX
          WRITE(10+I,REC=3) EADJ0(I)
          WRITE(10+I,REC=4) FINE
          WRITE(10+I,REC=5) 2*PI/A0
      END DO

      X=1
      Y=1
      Z=1
      DO I=1,N
          READ(1,*) CHA
          DO L=1,8
              IF(L.EQ.5) THEN
                  READ(1,*) ARR,ARR,ARR,ARR,ARR,ARR,REA(1),REA(2)
              ELSE IF(L.EQ.6) THEN
                  READ(1,*) REA(3),REA(4),REA(5),REA(6),REA(7),REA(8),REA(9),REA(10)
              ELSE IF(L.EQ.7) THEN
                  READ(1,*) REA(11),REA(12),REA(13),REA(14)
              ELSE
                  READ (1,*) ARR
              ENDIF
          END DO
          IF(X.EQ.(MESHNU/2)+1) THEN
              IF(Y.EQ.Z) THEN
                  Y=Y+1
                  Z=1
              ELSE
                  Z=Z+1
              ENDIF
              X=Y
          ENDIF
          CALL FILLINDEX(X,Y,Z,J)
          DO IJ=1,48
              DO LI=1,MSH
                  WRITE(10+LI,REC=11+J(IJ)) -((REA(2*LI-1)+REA(2*LI))/2.+EADJ(LI))
              END DO
          END DO
          X=X+1
      END DO
      CLOSE(1)

      WRITE(*,*) 'CONVERSION OF ABINIT COARSE MESH COMPLETED'
      WRITE(*,*) ' '

      WRITE(*,*) 'STARTING CONVERSION FROM ABINIT FINE MESH FILE'
      WRITE(*,*) ' '

      OPEN(2,FILE=ABINAMEF,FORM='FORMATTED')
      READ(2,*) CHA

      IC=10+MESHNU*MESHNU*MESHNU

      MESHNU=2*I1
      FBFRAC=.1
      WAVMAX=2*FBFRAC*PI/A0
      MSIZE=2*WAVMAX/(MESHNU-1)
      FINE=.FALSE.

      DO I=1,MSH
          WRITE(10+I,REC=1+IC) MESHNU
          WRITE(10+I,REC=2+IC) WAVMAX
          WRITE(10+I,REC=4+IC) FINE
          WRITE(10+I,REC=5+IC) 2*PI/A0
      END DO

      X=1
      Y=1
      Z=1
      DO I=1,N
          READ(2,*) CHA ! READING DUMMY INFORMATION LINE
          DO L=1,8
              IF(L.EQ.5) THEN
                  READ(2,*) ARR,ARR,ARR,ARR,ARR,ARR,REA(1),REA(2)   ! READING 6*DUMMY BANDS, THEN 2 * SPLIT-OFF BAND
              ELSE IF(L.EQ.6) THEN
                  READ(2,*) REA(3),REA(4),REA(5),REA(6),REA(7),REA(8),REA(9),REA(10) ! READING 2 * LIGHT HOLE BAND, 2 * HEAVY HOLE BAND, 2 * 1ST CONDUCTION BAND, 2 UPPER P-LIKE CONDUCTIONBANDS
              ELSE IF(L.EQ.7) THEN
                  READ(2,*) REA(11),REA(12),REA(13),REA(14) ! 2 * 2 UPPER P-LIKE CONDUCTIONBANDS
              ELSE
                  READ (2,*) ARR ! READING DUMMY BAND LINE
              ENDIF
          END DO
          IF(X.EQ.(MESHNU/2)+1) THEN
              IF(Y.EQ.Z) THEN
                  Y=Y+1
                  Z=1
              ELSE
                  Z=Z+1
              ENDIF
              X=Y
          ENDIF
          CALL FILLINDEX(X,Y,Z,J)
          DO IJ=1,48 ! 48 SYMERTRY POINTS
              DO LI=1,MSH ! BANDS
                  WRITE(10+LI,REC=IC+11+J(IJ)) -((REA(2*LI-1)+REA(2*LI))/2.+EADJ(LI))
              END DO
          END DO
          X=X+1
      END DO
      CLOSE(2)

      WRITE(*,*) 'CONVERSION OF ABINIT COARSE MESH COMPLETED'
      WRITE(*,*) ' '

      DO I=1,MSH
          CLOSE(10+I)
      END DO

      WRITE(*,*) 'ABINIT CALCULATIONS CONVERTED TO KPBAND FORMAT. FILES STORED'

      END PROGRAM

