!     IF ABINIT VALUES ARE USED: PICK INDECES OF STORED ENERGIES IN ORDER TO CALCULATE THE GRADIENTS
      SUBROUTINE GRADINDEX(AX,I,I1,I2,X,Y,Z)
      USE halvorinit
      INTEGER :: AX,I,I1,I2,X,Y,Z
      I1=I+MESHNU**(AX-1)
      I2=I-MESHNU**(AX-1)
!     CORRECATING INDECIES FOR CROSSINGS OF THE "NEGATIVE" BORDERS OF 1BZ
      IF( ((AX.EQ.1).AND.(X.EQ.0)).OR.((AX.EQ.2).AND.(Y.EQ.0)).OR.((AX.EQ.3).AND.(Z.EQ.0)) )THEN
          I1=I1+MESHNU**(AX-1)
          I2=I2+MESHNU**(AX-1)
      ENDIF
!     CORRECATING INDECIES FOR CROSSINGS OF THE "POSITIVE" BORDERS OF 1BZ
      IF( ((AX.EQ.1).AND.(X.EQ.MESHNU-1)).OR.((AX.EQ.2).AND.(Y.EQ.MESHNU-1)).OR.((AX.EQ.3).AND.(Z.EQ.MESHNU-1)) )THEN
          I1=I1-MESHNU**(AX-1)
          I2=I2-MESHNU**(AX-1)
      ENDIF
      END SUBROUTINE

!     IF ABINIT VALUES ARE USED: PICK INDECES OF STORED ENERGIES IN ORDER TO CALCULATE THE SECOND DERIVATIVES
      SUBROUTINE SDINDEX(AX,I,I1,I2,I3,I4,X,Y,Z)
      USE halvorinit
      INTEGER :: AX,I,I1,I2,I3,I4,X,Y,Z
      LOGICAL :: BACKX,FORWARDX,BACKY,FORWARDY,BACKZ,FORWARDZ
      BACKX=.FALSE.
      FORWARDX=.FALSE.
      BACKY=.FALSE.
      FORWARDY=.FALSE.
      BACKZ=.FALSE.
      FORWARDZ=.FALSE.
      IF(AX.LE.3)THEN
          I1=I+MESHNU**(AX-1)
          I2=I
          I3=I
          I4=I-MESHNU**(AX-1)
!         CHECKING FOR CROSSING OF THE "NEGATIVE" BORDER OF 1BZ
          IF((AX.EQ.1).AND.(X.EQ.0).OR.(AX.EQ.2).AND.(Y.EQ.0).OR.(AX.EQ.3).AND.(Z.EQ.0)) FORWARDX=.TRUE.
!         CHECKING FOR CROSSING OF THE "POSITIVE" BORDER OF 1BZ
          IF((AX.EQ.1).AND.(X.EQ.(MESHNU-1)).OR.(AX.EQ.2).AND.(Y.EQ.(MESHNU-1)).OR.(AX.EQ.3).AND.(Z.EQ.(MESHNU-1))) BACKX=.TRUE.
          IF(FORWARDX)THEN ! CORRECTING IN POSITVE DIRECTION
              I1=I1+MESHNU**(AX-1)
              I2=I2+MESHNU**(AX-1)
              I3=I3+MESHNU**(AX-1)
              I4=I4+MESHNU**(AX-1)
          ENDIF
          IF(BACKX)THEN ! CORRECTING IN NEGATIVE DIRECTION
              I1=I1-MESHNU**(AX-1)
              I2=I2-MESHNU**(AX-1)
              I3=I3-MESHNU**(AX-1)
              I4=I4-MESHNU**(AX-1)
          ENDIF
      ELSEIF(AX.EQ.4)THEN
          I1=I+1+MESHNU
          I2=I+1-MESHNU
          I3=I-1+MESHNU
          I4=I-1-MESHNU
      ELSEIF(AX.EQ.5)THEN
          I1=I+1+MESHNU**2
          I2=I+1-MESHNU**2
          I3=I-1+MESHNU**2
          I4=I-1-MESHNU**2
      ELSE
          I1=I+MESHNU+MESHNU**2
          I2=I+MESHNU-MESHNU**2
          I3=I-MESHNU+MESHNU**2
          I4=I-MESHNU-MESHNU**2
      ENDIF
      IF(AX.GE.4)THEN
!         CHECKING FOR CROSSING OF THE "NEGATIVE" OR "POSITIVE" BORDERS OF 1BZ
          IF(((AX.EQ.4).OR.(AX.EQ.5)).AND.(X.EQ.0)) FORWARDX=.TRUE.
          IF(((AX.EQ.4).OR.(AX.EQ.5)).AND.(X.EQ.MESHNU-1)) BACKX=.TRUE.
          IF(((AX.EQ.4).OR.(AX.EQ.6)).AND.(Y.EQ.0)) FORWARDY=.TRUE.
          IF(((AX.EQ.4).OR.(AX.EQ.6)).AND.(Y.EQ.MESHNU-1)) BACKY=.TRUE.
          IF(((AX.EQ.5).OR.(AX.EQ.6)).AND.(Z.EQ.0)) FORWARDZ=.TRUE.
          IF(((AX.EQ.5).OR.(AX.EQ.6)).AND.(Z.EQ.MESHNU-1)) BACKZ=.TRUE.
          IF(FORWARDX)THEN ! CORRECTING IN POSITVE DIRECTION
              I1=I1+1
              I2=I2+1
              I3=I3+1
              I4=I4+1
          ENDIF
          IF(BACKX)THEN ! CORRECTING IN NEGATIVE DIRECTION
              I1=I1-1
              I2=I2-1
              I3=I3-1
              I4=I4-1
          ENDIF
          IF(FORWARDY)THEN ! CORRECTING IN POSITVE DIRECTION
              I1=I1+MESHNU
              I2=I2+MESHNU
              I3=I3+MESHNU
              I4=I4+MESHNU
          ENDIF
          IF(BACKY)THEN ! CORRECTING IN NEGATIVE DIRECTION
              I1=I1-MESHNU
              I2=I2-MESHNU
              I3=I3-MESHNU
              I4=I4-MESHNU
          ENDIF
          IF(FORWARDZ)THEN ! CORRECTING IN POSITVE DIRECTION
              I1=I1+MESHNU**2
              I2=I2+MESHNU**2
              I3=I3+MESHNU**2
              I4=I4+MESHNU**2
          ENDIF
          IF(BACKZ)THEN ! CORRECTING IN NEGATIVE DIRECTION
              I1=I1-MESHNU**2
              I2=I2-MESHNU**2
              I3=I3-MESHNU**2
              I4=I4-MESHNU**2
          ENDIF
      ENDIF

      END SUBROUTINE


!     PROGRAM FOR COMBINING BAND STRUCTURES, ENERGY GRADIENTS AND ENERGY SECOND DERIVATIVES  FROM KPBAND AND ABINIT
      PROGRAM ABINITIO

      USE halvorinit

!     TECHNICAL PARAMETERS
      INTEGER            :: X,Y,Z
      INTEGER, PARAMETER :: N=MS
      REAL(KIND=DBL)     :: E(MSH),EGR(3,MSH),ESD(6,MSH),E11,E22,E33,E44
      INTEGER            :: I,J,I1,I2,I3,I4,AX,COUNTER
      LOGICAL            :: XDIV,YDIV,ZDIV
      CHARACTER(LEN=12)  :: ENNAMEA(7),ABINAMEC,ABINAMEF

!     INFORMATION PARAMETERS
      REAL(KIND=DBL) :: WAVMAX,LC,MSIZE

!     INITIALIZING PARAMETERS WITH VALUES STORED IN ABINIT.INI

      OPEN(50,FILE='ABINIT.INI',ACCESS='DIRECT',FORM='UNFORMATTED',STATUS='OLD',RECL=360)
      READ (50,REC=1) ABINAMEC,ABINAMEF,ENNAMEA,ENNAME,GRNAME,SDNAME
      CLOSE(50)

      WRITE(*,*) '********ABINITDIFFERENTIATOR********'
      WRITE(*,*) 'PROGRAM FOR DIFFERENTIATING BANDSTRUCTURES FROM ABINIT'

!     LOADING FROM FILES
      DO J=1,MSH
!         UNITS [100,199] : FILES FROM ABINIT
!         UNITS [200,299] : FINAL BAND STRUCTURE FILES
!         UNITS X2Y (EG. 225) : ENERGY FILES
!         UNITS X3Y (EG. 136) : GRADIENT FILES
!         UNITS X4Y (EG. 241) : SECOND DERIVATIVE FILES

!         LOADING AND INITALIZING ENERGY FILES
          OPEN(120+J,FILE=ENNAMEA(J),ACCESS='DIRECT',FORM='UNFORMATTED',RECL=8,STATUS='UNKNOWN')
          OPEN(220+J,FILE=ENNAME(J),ACCESS='DIRECT',FORM='UNFORMATTED',RECL=8,STATUS='UNKNOWN')
          READ(120+J,REC=1) MESHNU
          WRITE(220+J,REC=1) MESHNU
          READ(120+J,REC=2) WAVMAX
          WRITE(220+J,REC=2) WAVMAX
          READ(120+J,REC=3) E(J)
          WRITE(220+J,REC=3) E(J)
          READ(120+J,REC=4) FINE
          WRITE(220+J,REC=4) FINE
          READ(120+J,REC=5) LC
          WRITE(220+J,REC=5) LC
!         INITIALIZING GRADIENT FILES
          OPEN(230+J,FILE=GRNAME(J),ACCESS='DIRECT',FORM='UNFORMATTED',RECL=24,STATUS='UNKNOWN')
          WRITE(230+J,REC=1) MESHNU
          WRITE(230+J,REC=2) WAVMAX
          WRITE(230+J,REC=4) FINE
          WRITE(230+J,REC=5) LC
!         INITIALIZING SECOND DERIVATIVE FILES
          OPEN(240+J,FILE=SDNAME(J),ACCESS='DIRECT',FORM='UNFORMATTED',RECL=48,STATUS='UNKNOWN')
          WRITE(240+J,REC=1) MESHNU
          WRITE(240+J,REC=2) WAVMAX
          WRITE(240+J,REC=4) FINE
          WRITE(240+J,REC=5) LC
      END DO
!     LOADING COARSE MESH
      I=0

      WRITE (*,*) ' '
      WRITE (*,*) 'PERFORMING COARSE MESH DIFFERENTIATION'
      WRITE (*,*) ' '

200   MSIZE=2*WAVMAX/(MESHNU-1)

      I=I+10
      DO Z=0,MESHNU-1
          DO Y=0,MESHNU-1
              DO X=0,MESHNU-1

                  I=I+1
                  DO J=1,MSH
                      READ(120+J,REC=I) E(J)
                      DO AX=1,3
                          CALL GRADINDEX(AX,I,I1,I2,X,Y,Z) ! PICKING RECORD INDEXES FROM ABINIT FILES FOR CALCULATING GRADIENT COORDINATES
                          READ(120+J,REC=I1) E11
                          READ(120+J,REC=I2) E22
                          EGR(AX,J)=0.5*(E11-E22)/MSIZE
                      END DO
                      DO AX=1,6
                          CALL SDINDEX(AX,I,I1,I2,I3,I4,X,Y,Z) ! PICKING RECORD INDEXES FROM ABINIT FILES FOR CALCULATING SECOND DERIVATIVES
                          READ(120+J,REC=I1) E11
                          READ(120+J,REC=I2) E22
                          READ(120+J,REC=I3) E33
                          READ(120+J,REC=I4) E44
                          ESD(AX,J)=0.25*(E11-E22-E33+E44)/(MSIZE**2)
                      END DO
!                     WRITING FINAL FILES FOR ENERGIES, GRADIENTS AND SECOND DERIVATIVES
                      WRITE(220+J,REC=I) E(J)
                      WRITE(230+J,REC=I) (EGR(AX,J),AX=1,3)
                      WRITE(240+J,REC=I) (ESD(AX,J),AX=1,6)
                  END DO !END J/BANDS
              END DO !END X
          END DO !END Y
      END DO !END Z

      IF(FINE)THEN
          READ(121,REC=I+1) MESHNU
          READ(121,REC=I+2) WAVMAX
          READ(121,REC=I+4) FINE
          READ(121,REC=I+5) LC
          DO J=1,MSH
              ! DEFINING HEADER OF FINAL ENERGY FILES FOR FINE MESH
              WRITE(220+J,REC=I+1) MESHNU
              WRITE(220+J,REC=I+2) WAVMAX
              WRITE(220+J,REC=I+4) FINE
              WRITE(220+J,REC=I+5) LC
              ! DEFINING HEADER OF FINAL GRADIENT FILES FOR FINE MESH
              WRITE(230+J,REC=I+1) MESHNU
              WRITE(230+J,REC=I+2) WAVMAX
              WRITE(230+J,REC=I+4) FINE
              WRITE(230+J,REC=I+5) LC
              ! DEFINING HEADER OF FINAL SECOND DERIVATIVE FILES FOR FINE MESH
              WRITE(240+J,REC=I+1) MESHNU
              WRITE(240+J,REC=I+2) WAVMAX
              WRITE(240+J,REC=I+4) FINE
              WRITE(240+J,REC=I+5) LC
          END DO
          WRITE (*,*) 'PERFORMING FINE MESH DIFFERENTIATION'
          WRITE (*,*) ' '
          GOTO 200
      ENDIF

      DO J=1,MSH
          CLOSE(120+J)
          CLOSE(220+J)
          CLOSE(230+J)
          CLOSE(240+J)
      END DO

99    FORMAT(6I8)

      END PROGRAM
