      PROGRAM ABINOTGENERATOR

!     TECHNICAL PARAMETERS:
      CHARACTER(LEN=4)   :: FNAME1='MCT1',FNAME2='MCT2',PSP1='80hg',PSP2='52te'
      INTEGER,PARAMETER  :: N=20,NN=210
!      INTEGER,PARAMETER  :: N=6,NN=21
      REAL               :: STARTING1(3,NN-N+1),ENDING1(3,NN-N+1),STARTING2(3,NN-N+1),ENDING2(3,NN-N+1)
      REAL               :: DK1=1./(N-0.5),DK2=.1/(N-0.5)

!     FILE INPUTS:

!     GENERAL:
      REAL   :: acell(3),rprim(3,3),znucl(2),xred(2,3)
      REAL   :: ecut=10.,ecutsm=0.5,pawecutdg=50.
      INTEGER :: ntypat=2,natom=2,typat(2),nband=64,nspinor=2,pawspnorb=1,ndtset=2

!     DATASET 1:
      INTEGER :: kptopt1=4,nshiftk1=4,ngkpt1(3),prtden1=1
      REAL    :: shiftk1(4,3),toldfe1=1.0D-6

!     DATASET 2:ABIGEN
      INTEGER :: iscf2=-2,getden2=-1,kptopt2=-(2*NN-2*N+1),ndivk2(2*NN-2*N+1),enunit2=1
      REAL    :: tolwfr2=1.0D-12
!      INTEGER :: iscf2=-2,getden2=-1,kptopt2=-3,ndivk2(3),enunit2=1
!      REAL    :: kptbounds2(4,3),tolwfr2=1.0D-12

!     I/O PARAMETERS:
      INTEGER :: optforces=2,optstress=1,prtwf=0,prtden=0,prteig=1,prtvol=1

!     LDA+U:
      INTEGER :: usepawu=1,lpawu(2)
      REAL    :: upawu(2)

      acell(1)=12.2575
      acell(2)=12.2575
      acell(3)=12.2575
      ngkpt1(1)=12
      ngkpt1(2)=12
      ngkpt1(3)=12
      rprim(1,1)=0.0
      rprim(1,2)=0.5
      rprim(1,3)=0.5
      rprim(2,1)=0.5
      rprim(2,2)=0.0
      rprim(2,3)=0.5
      rprim(3,1)=0.5
      rprim(3,2)=0.5
      rprim(3,3)=0.0
      xred(1,1)=0.0
      xred(1,2)=0.0
      xred(1,3)=0.0
      xred(2,1)=0.25
      xred(2,2)=0.25
      xred(2,3)=0.25
      shiftk1(1,1)=0.5
      shiftk1(1,2)=0.5
      shiftk1(1,3)=0.5
      shiftk1(2,1)=0.5
      shiftk1(2,2)=0.0
      shiftk1(2,3)=0.0
      shiftk1(3,1)=0.0
      shiftk1(3,2)=0.5
      shiftk1(3,3)=0.0
      shiftk1(4,1)=0.0
      shiftk1(4,2)=0.0
      shiftk1(4,3)=0.5
      znucl(1)=80.
      znucl(2)=52.
      typat(1)=1
      typat(2)=2
      lpawu(1)=2
      lpawu(2)=-1
      upawu(1)=8.
      upawu(2)=0.

      DO I=1,N-1
          DO J=1,I
              ndivk2(2*J+I*(I-1)-1)=N-I
              ndivk2(2*J+I*(I-1))=1
              STARTING1(1,J+(I*(I-1))/2)=(DK1/2.)*(I+J-1)
              STARTING1(2,J+(I*(I-1))/2)=(DK1/2.)*(I+J-1)
              STARTING1(3,J+(I*(I-1))/2)=(DK1/2.)*(2*I-1)
              ENDING1(1,J+(I*(I-1))/2)=(DK1/2.)*(I+J-1)
              ENDING1(2,J+(I*(I-1))/2)=0.5+(DK1/2.)*(J-.5)
              ENDING1(3,J+(I*(I-1))/2)=0.5+(DK1/2.)*(I-.5)
              STARTING2(1,J+(I*(I-1))/2)=(DK2/2.)*(I+J-1)
              STARTING2(2,J+(I*(I-1))/2)=(DK2/2.)*(I+J-1)
              STARTING2(3,J+(I*(I-1))/2)=(DK2/2.)*(2*I-1)
              ENDING2(1,J+(I*(I-1))/2)=(DK2/2.)*(I+J-1)
              ENDING2(2,J+(I*(I-1))/2)=0.05+(DK2/2.)*(J-.5)
              ENDING2(3,J+(I*(I-1))/2)=0.05+(DK2/2.)*(I-.5)
          END DO
      END DO
      ndivk2(2*NN-2*N+1)=N-1
      STARTING1(1,NN-N+1)=0.5+DK1/4.
      STARTING1(2,NN-N+1)=0.5+DK1/4.
      STARTING1(3,NN-N+1)=1.
      ENDING1(1,NN-N+1)=1.
      ENDING1(2,NN-N+1)=1.
      ENDING1(3,NN-N+1)=1.
      STARTING2(1,NN-N+1)=0.05+DK2/4.
      STARTING2(2,NN-N+1)=0.05+DK2/4.
      STARTING2(3,NN-N+1)=.1
      ENDING2(1,NN-N+1)=.1
      ENDING2(2,NN-N+1)=.1
      ENDING2(3,NN-N+1)=.1

!     WRITING THE '.files' FILES:

      WRITE(*,*) ' '
      OPEN(12,FILE=FNAME1//'.files')
      WRITE(12,100) FNAME1//'.in'
      WRITE(12,100) FNAME1//'.out'
      WRITE(12,100) FNAME1//'i'
      WRITE(12,100) FNAME1//'o'
      WRITE(12,100) FNAME1//'tmp'
      WRITE(12,100) '../Psps/'//PSP1//'.lda.atompaw'
      WRITE(12,100) '../Psps/'//PSP2//'.lda.atompaw'
      CLOSE(12)
      WRITE(*,*) 'COARSE MESH RUNNING FILE "',FNAME1,'.files" CREATED'
      WRITE(*,*) ' '
      OPEN(22,FILE=FNAME2//'.files')
      WRITE(22,100) FNAME2//'.in'
      WRITE(22,100) FNAME2//'.out'
      WRITE(22,100) FNAME2//'i'
      WRITE(22,100) FNAME2//'o'
      WRITE(22,100) FNAME2//'tmp'
      WRITE(22,100) '../Psps/'//PSP1//'.lda.atompaw'
      WRITE(22,100) '../Psps/'//PSP2//'.lda.atompaw'
      CLOSE(22)
      WRITE(*,*) 'FINE MESH RUNNING FILE "',FNAME2,'.files" CREATED'
      WRITE(*,*) ' '

!     WRITING THE '.in' FILES:

      OPEN(11,FILE=FNAME1//'.in')
      WRITE(11,100) '# ==========================================='
      WRITE(11,100) '# Input for the PAW calculations'
      WRITE(11,100) '# Zinc blende MCT structure'
      WRITE(11,100) '# ==========================================='
      WRITE(11,100) ' '
      WRITE(11,100) '#Cell and atom definitions'
      WRITE(11,101) ' acell',acell(1),acell(2),acell(3)
      WRITE(11,101) ' rprim',rprim(1,1),rprim(1,2),rprim(1,3)
      WRITE(11,101) '      ',rprim(2,1),rprim(2,2),rprim(2,3)
      WRITE(11,101) '      ',rprim(3,1),rprim(3,2),rprim(3,3)
      WRITE(11,102) ' ntypat',ntypat,'natom',natom,'typat',typat(1),typat(2)
      WRITE(11,101) ' xred',xred(1,1),xred(1,2),xred(1,3)
      WRITE(11,101) '     ',xred(2,1),xred(2,2),xred(2,3)
      WRITE(11,103) ' znucl',znucl(1),znucl(2)
      WRITE(11,104) ' nband',nband
      WRITE(11,104) ' nspinor',nspinor
      WRITE(11,100) ' '
      WRITE(11,100) '#Grid definitions'
      WRITE(11,105) ' ecut',ecut
      WRITE(11,105) ' ecutsm',ecutsm
      WRITE(11,105) ' pawecutdg',pawecutdg
      WRITE(11,106) ' pawspnorb',pawspnorb
      WRITE(11,100) ' '
      WRITE(11,104) 'ndtset',ndtset
      WRITE(11,100) ' '
      WRITE(11,100) '#Dataset 1 : usual self-consistent calculation'
      WRITE(11,104) 'kptopt1',kptopt1
      WRITE(11,104) 'nshiftk1',nshiftk1
      WRITE(11,101) 'shiftk1',shiftk1(1,1),shiftk1(1,2),shiftk1(1,3)
      WRITE(11,101) '       ',shiftk1(2,1),shiftk1(2,2),shiftk1(2,3)
      WRITE(11,101) '       ',shiftk1(3,1),shiftk1(3,2),shiftk1(3,3)
      WRITE(11,101) '       ',shiftk1(4,1),shiftk1(4,2),shiftk1(4,3)
      WRITE(11,107) 'ngkpt1',ngkpt1(1),ngkpt1(2),ngkpt1(3)
      WRITE(11,104) 'prtden1',prtden1
      WRITE(11,106) 'toldfe1',toldfe1
      WRITE(11,100) ' '
      WRITE(11,100) '#Dataset 2 : the band structure'
      WRITE(11,106) 'iscf2',iscf2
      WRITE(11,106) 'getden2',getden2
      WRITE(11,106) 'kptopt2',kptopt2
      WRITE(11,100) 'ndivk2'
      DO I=1,N-1
          DO J=1,I
              WRITE(11,108) ndivk2(2*J+I*(I-1)-1)
              WRITE(11,108) ndivk2(2*J+I*(I-1))
          END DO
      END DO
      WRITE(11,108) ndivk2(2*NN-2*N+1)
      WRITE(11,100) 'kptbounds2'
      DO I=1,N-1
          DO J=1,I
              WRITE(11,101) '          ',STARTING1(1,J+(I*(I-1))/2),STARTING1(2,J+(I*(I-1))/2),STARTING1(3,J+(I*(I-1))/2)
              WRITE(11,101) '          ',ENDING1(1,J+(I*(I-1))/2),ENDING1(2,J+(I*(I-1))/2),ENDING1(3,J+(I*(I-1))/2)
          END DO
      END DO
      WRITE(11,101) '          ',STARTING1(1,NN-N+1),STARTING1(2,NN-N+1),STARTING1(3,NN-N+1)
      WRITE(11,101) '          ',ENDING1(1,NN-N+1),ENDING1(2,NN-N+1),ENDING1(3,NN-N+1)
      WRITE(11,105) 'tolwfr2',tolwfr2
      WRITE(11,109) 'enunit2',enunit2,'# Output energy in eV'
      WRITE(11,100) ' '
      WRITE(11,100) '#I/O parameters'
      WRITE(11,110) ' optforces',optforces,'optstress',optstress
      WRITE(11,111) ' prtwf',prtwf,'prtden',prtden,'prteig',prteig,'prtvol',prtvol
      WRITE(11,100) ' '
      WRITE(11,100) '# LDA+U'
      WRITE(11,104) 'usepawu',usepawu
      WRITE(11,112) 'lpawu',lpawu(1),lpawu(2)
      WRITE(11,113) 'upawu',upawu(1),upawu(2),'eV'
      CLOSE(11)
      WRITE(*,*) 'COARSE MESH INPUT FILE "',FNAME1,'.in" CREATED'
      WRITE(*,*) ' '

      OPEN(21,FILE=FNAME2//'.in')
      WRITE(21,100) '# ==========================================='
      WRITE(21,100) '# Input for the PAW calculations'
      WRITE(21,100) '# Zinc blende MCT structure'
      WRITE(21,100) '# ==========================================='
      WRITE(21,100) ' '
      WRITE(21,100) '#Cell and atom definitions'
      WRITE(21,101) ' acell',acell(1),acell(2),acell(3)
      WRITE(21,101) ' rprim',rprim(1,1),rprim(1,2),rprim(1,3)
      WRITE(21,101) '      ',rprim(2,1),rprim(2,2),rprim(2,3)
      WRITE(21,101) '      ',rprim(3,1),rprim(3,2),rprim(3,3)
      WRITE(21,102) ' ntypat',ntypat,'natom',natom,'typat',typat(1),typat(2)
      WRITE(21,101) ' xred',xred(1,1),xred(1,2),xred(1,3)
      WRITE(21,101) '     ',xred(2,1),xred(2,2),xred(2,3)
      WRITE(21,103) ' znucl',znucl(1),znucl(2)
      WRITE(21,104) ' nband',nband
      WRITE(21,104) ' nspinor',nspinor
      WRITE(21,100) ' '
      WRITE(21,100) '#Grid definitions'
      WRITE(21,105) ' ecut',ecut
      WRITE(21,105) ' ecutsm',ecutsm
      WRITE(21,105) ' pawecutdg',pawecutdg
      WRITE(21,106) ' pawspnorb',pawspnorb
      WRITE(21,100) ' '
      WRITE(21,104) 'ndtset',ndtset
      WRITE(21,100) ' '
      WRITE(21,100) '#Dataset 1 : usual self-consistent calculation'
      WRITE(21,104) 'kptopt1',kptopt1
      WRITE(21,104) 'nshiftk1',nshiftk1
      WRITE(21,101) 'shiftk1',shiftk1(1,1),shiftk1(1,2),shiftk1(1,3)
      WRITE(21,101) '       ',shiftk1(2,1),shiftk1(2,2),shiftk1(2,3)
      WRITE(21,101) '       ',shiftk1(3,1),shiftk1(3,2),shiftk1(3,3)
      WRITE(21,101) '       ',shiftk1(4,1),shiftk1(4,2),shiftk1(4,3)
      WRITE(21,107) 'ngkpt1',ngkpt1(1),ngkpt1(2),ngkpt1(3)
      WRITE(21,104) 'prtden1',prtden1
      WRITE(21,106) 'toldfe1',toldfe1
      WRITE(21,100) ' '
      WRITE(21,100) '#Dataset 2 : the band structure'
      WRITE(21,106) 'iscf2',iscf2
      WRITE(21,106) 'getden2',getden2
      WRITE(21,106) 'kptopt2',kptopt2
      WRITE(21,100) 'ndivk2'
      DO I=1,N-1
          DO J=1,I
              WRITE(21,108) ndivk2(2*J+I*(I-1)-1)
              WRITE(21,108) ndivk2(2*J+I*(I-1))
          END DO
      END DO
      WRITE(21,108) ndivk2(2*NN-2*N+1)
      WRITE(21,100) 'kptbounds2'
      DO I=1,N-1
          DO J=1,I
              WRITE(21,101) '          ',STARTING2(1,J+(I*(I-1))/2),STARTING2(2,J+(I*(I-1))/2),STARTING2(3,J+(I*(I-1))/2)
              WRITE(21,101) '          ',ENDING2(1,J+(I*(I-1))/2),ENDING2(2,J+(I*(I-1))/2),ENDING2(3,J+(I*(I-1))/2)
          END DO
      END DO
      WRITE(21,101) '          ',STARTING2(1,NN-N+1),STARTING2(2,NN-N+1),STARTING2(3,NN-N+1)
      WRITE(21,101) '          ',ENDING2(1,NN-N+1),ENDING2(2,NN-N+1),ENDING2(3,NN-N+1)
      WRITE(21,105) 'tolwfr2',tolwfr2
      WRITE(21,109) 'enunit2',enunit2,'# Output energy in eV'
      WRITE(21,100) ' '
      WRITE(21,100) '#I/O parameters'
      WRITE(21,110) ' optforces',optforces,'optstress',optstress
      WRITE(21,111) ' prtwf',prtwf,'prtden',prtden,'prteig',prteig,'prtvol',prtvol
      WRITE(21,100) ' '
      WRITE(21,100) '# LDA+U'
      WRITE(21,104) 'usepawu',usepawu
      WRITE(21,112) 'lpawu',lpawu(1),lpawu(2)
      WRITE(21,113) 'upawu',upawu(1),upawu(2),'eV'
      CLOSE(21)
      WRITE(*,*) 'FINE MESH INPUT FILE "',FNAME2,'.in" CREATED'
      WRITE(*,*) ' '

100   FORMAT(A)
101   FORMAT(A,3F11.6)
102   FORMAT(A7,I2,A7,I2,A7,2I2)
103   FORMAT(A,2F7.3)
104   FORMAT(A,I4)
105   FORMAT(A,F9.4)
106   FORMAT(A,I2)
107   FORMAT(A,3I5)
108   FORMAT(I)
109   FORMAT(A,I2,A25)
110   FORMAT(A12,I3,A12,I3)
111   FORMAT(A8,I3,A8,I3,A8,I3,A8,I3)
112   FORMAT(A,2I4)
113   FORMAT(A,2F7.3,A5)
      END PROGRAM

