!     THIS PROGRAM CREATES A INITIALIZATION FILE FOR THE PROGRAM
!     "SCRATES". IT CONTAINS ALL DATA NEEDED TO SET UP SCRATES FOR A RUN.
!     
 
 
      FUNCTION LAST(STR)
      INTEGER :: LAST
      CHARACTER(LEN=*) :: STR
 
      LAST=LEN(STR)
10    IF (STR(LAST:LAST).EQ.' '.AND.LAST.GT.1) THEN
          LAST=LAST-1
          GOTO 10
      ENDIF

      END
 
 
      PROGRAM SCRINI
      USE Rateinit

      CHARACTER(LEN=25) :: NAM
      CHARACTER(LEN=8)  :: MAT
      CHARACTER(LEN=35) :: MENU1(8),MENU2(4)
      CHARACTER(LEN=50) :: MENU3(3)
      CHARACTER(LEN=12) :: FNAME
      CHARACTER(LEN=1)  :: DUMMY
      
      INTEGER :: I,J,LAST,L

!     INITIALIZING VARIABLES 
      DATA MENU1/'CHANGE SCATTERING MECHANISM',&
                 'CHANGE TEMPERATURE',&
                 'CHANGE INITIAL AND FINAL BANDS',&
                 'CHANGE FILENAMES',&
                 'ALTER NAMES AND NUMBER OF BANDS',&
                 'SHOW ALL DATA',&
                 'SPECIFY HOW TO CALCULATE OVERLAP INTEGRAL',&
                 'SAVE AND EXIT'/
      DATA MENU2/'RENAME BAND','ADD BAND','DISCARD BAND','LIST BANDS'/
      DATA MENU3/'BY EIGENVECTORS OF NxN HAMILTONIAN',&
                 'BY ANALYTICAL EXPRESSIONS AFTER Wiley',&
                 'BY ASSUMING UNITY OVERLAP INTEGRAL'/
      DATA FNAME/'SCRATES.INI'/


!     SET APPROPRIATE RECORD LENGTH BY ASSIGNING COMPUTER TYPE TO ANT
!     ALTERNATIVES ARE: VAX,PC 
      ANT=PC
      IF (MOD(BYTES,ANT).NE.0) THEN
          LEN=BYTES/ANT+1
      ELSE
          LEN=BYTES/ANT
      ENDIF


      OPEN(10,FILE='SCRATES.INI',ACCESS='DIRECT',FORM='UNFORMATTED',&
          IOSTAT=ERROR,STATUS='OLD',RECL=LEN)
      CLOSE(10)
     
      WRITE(*,*) BYTES, LEN
      IF (ERROR.NE.0) THEN
 
!         PRINT MESSAGE
          WRITE (*,9905) 'NO INITIALIZATION FILE IS FOUND'
          WRITE (*,9905) 'FILE SCRATES.INI HAS BEEN CREATED'
 
!         SET DEFAULT VALUES 
          BANNUM=0
          INIT=0
          FINAL=0
          MECH=0
          T=300.0
          OVMETH=1
          DO I=1,MAXBAN
              ENFIL(I)=' '
              GRFIL(I)=' '
              VEFIL(I)=' '
          END DO
          OUTFIL=' '

!         TESTING
          WRITE(*,*) 'LEN = ', LEN 


!         WRITING DATA TO FILE
          OPEN (10,FILE=FNAME,ACCESS='DIRECT',FORM='UNFORMATTED',STATUS='NEW',RECL=LEN)
          WRITE(10,REC=1) BANNUM,BNAM,ENFIL,GRFIL,VEFIL,INIT,FINAL,OUTFIL,T,MECH,OVMETH
          CLOSE (10)
 
      ENDIF
       
 
!     MODIFY THE INITIALIZATION FILE 
 
      OPEN (10,FILE=FNAME,ACCESS='DIRECT',FORM='UNFORMATTED',&
             STATUS='OLD',RECL=LEN)
      READ (10,REC=1) BANNUM,BNAM,ENFIL,GRFIL,VEFIL,INIT,FINAL,OUTFIL,T,MECH,OVMETH
      CLOSE (10)

100   WRITE (*,9905) '....SCRINI MAIN MENU.....'
      WRITE (*,9905) 'YOU MAY :'
      WRITE (*,9915) (I,MENU1(I),I=1,8)
      WRITE (*,9905) 'ENTER SELECTION:'
150   READ  (*,*) J
      GOTO (111,112,113,114,116,117,118,115) J
      WRITE(*,*) 'ILLEGAL CHOICE! TRY ONCE MORE.'
      GOTO 150
 
!     CHANGE SCATTERING MECHANISM 
111   WRITE (*,9905) '....CHANGE SCATTERING MECHANISM....' 
      IF (MECH.NE.0) THEN
          L=LAST(SCRNAM(MECH))
          WRITE (*,9905) 'THE CURRENT SCATTERING MECHANISM IS : '// &
                         SCRNAM(MECH)(1:L)
      ELSE
          WRITE (*,9905) 'THE CURRENT SCATTERING MECHANISM IS : '// &
                         'NOT DEFINED'
      ENDIF
      WRITE (*,9905) 'THE AVAILABLE SCATTERING MECHANISMS ARE:'
      WRITE (*,9915) (I,SCRNAM(I),I=1,SCRNUM)
250   WRITE (*,9905) 'ENTER SELECTION (0=UNCHANGED):'
      READ  (*,*) J
      IF (J.LT.0.OR.J.GT.SCRNUM) THEN
          WRITE(*,*) 'ILLEGAL CHOICE! TRY ONCE MORE.'
          GOTO 250
      ENDIF
      IF (J.NE.0) MECH=J
      GOTO 100
 
!     CHANGE TEMPERATURE 
112   WRITE (*,9945) '....CHANGE TEMPERATURE....'
      WRITE (*,9925) 'THE CURRENT TEMPERATURE IS ',T
450   WRITE (*,9905) 'ENTER NEW TEMPERATURE [K] :'
      READ (*,*) T
      IF (T.LT.0) THEN
          WRITE (*,*) 'THERE IS NO NEGATIVE TEMPERATURES ON THE ' &
                    //'KELVIN SCALE'
          WRITE (*,*) 'TRY ONCE MORE.'
          GOTO 450
      ENDIF
      GOTO 100
 
!     CHANGE INITIAL AND FINAL BANDS 
113   WRITE (*,9945) '....CHANGE INITIAL AND FINAL BANDS....'
      WRITE (*,*) 'THE CURRENT SETTING IS :'
      INITOK = INIT.GE.1.AND.INIT.LE.BANNUM
      IF (INITOK) THEN
          L=LAST(BNAM(INIT))
          WRITE (*,9910) '1. INITIAL BAND :  THE ',BNAM(INIT)(1:L)// &
                         ' BAND'
      ELSE
          WRITE (*,*) '1. INITIAL BAND :  NOT DEFINED'
      ENDIF
      FINOK=FINAL.GE.1.AND.FINAL.LE.BANNUM
      IF (FINOK) THEN
          L=LAST(BNAM(FINAL))
          WRITE (*,9910) '2. FINAL BAND   :  THE ',BNAM(FINAL)(1:L) &
                       //' BAND'
      ELSE
          WRITE (*,*) '2. FINAL BAND   :  NOT DEFINED'
      ENDIF
      IF (BANNUM.EQ.0) THEN
          WRITE (*,9905) 'NO BANDS ARE DEFINED.'
          WRITE (*,*) 'YOU MUST DEFINE THE AVAILABLE BANDS BEFORE YOU' &
                    //' CAN SET INITIAL AND FINAL BANDS.'
          WRITE (*,9905) 'PRESS RETURN TO CONTINUE.'
          READ  (*,'(A)') DUMMY
          GOTO 100
      ENDIF
550   WRITE (*,9905) 'WHICH DO YOU WANT TO CHANGE (0=NONE) ? '
      READ (*,*) I
      IF (I.EQ.0) GOTO 100
      IF (I.NE.1.AND.I.NE.2) THEN
          WRITE (*,*) 'ILLEGAL CHOICE! TRY ONCE MORE.'
          GOTO 550
      ELSEIF (I.EQ.1) THEN
          WRITE (*,*) 'THE POSSIBLE INITIAL BANDS ARE : '
          DO I=1,BANNUM
              L=LAST(BNAM(I)) 
              WRITE (*,9915) I,BNAM(I)(1:L)//' BAND'
          END DO
500       WRITE (*,9905) 'MAKE A SELECTION (0=NONE) :'
          READ  (*,*) I
          IF (I.EQ.0) GOTO 113
          IF (I.GE.1.AND.I.LE.BANNUM) THEN
              INIT=I
          ELSE
              WRITE (*,*) 'THERE IS NO SUCH BAND.'
              WRITE (*,*) 'TRY ONCE MORE.'
              GOTO 500
          ENDIF
      ELSE
          WRITE (*,*) 'THE POSSIBLE FINAL BANDS ARE : '
          DO I=1,BANNUM
              L=LAST(BNAM(I)) 
              WRITE (*,9915) I,BNAM(I)(1:L)//' BAND'
          END DO
525       WRITE (*,9905) 'MAKE A SELECTION (0=NONE) :'
          READ  (*,*) I
          IF (I.EQ.0) GOTO 113
          IF (I.GE.1.AND.I.LE.BANNUM) THEN
              FINAL=I
          ELSE
               WRITE (*,*) 'THERE IS NO SUCH BAND.'
               WRITE (*,*) 'TRY ONCE MORE.'
               GOTO 525
          ENDIF
      ENDIF
      GOTO 113
 
!     CHANGING FILENAMES 
114   WRITE (*,9945) '....CHANGE FILENAMES....'
      WRITE (*,*) 'THE FILENAMES ARE:'
      WRITE(*,9940) ' ','ENERGIES    ','GRADIENTS   ','EIGENVECTORS'
      DO I=1,BANNUM
          L=LAST(BNAM(I))
          WRITE (*,9935) I,BNAM(I)(1:L)//' BAND :',ENFIL(I), &
                         GRFIL(I),VEFIL(I)
      END DO
      WRITE(*,*) ' '
      WRITE(*,9915) BANNUM+1,'OUTPUT FILE : '//OUTFIL
350   WRITE (*,9905) 'WHICH DO YOU WANT TO CHANGE (0=NONE) ?'
      READ  (*,*) I
      IF (I.EQ.0) GOTO 100
      IF (I.GT.(BANNUM+1).OR.I.LT.1) THEN
          WRITE(*,*) 'ILLEGAL CHOICE! TRY ONCE MORE'
          GOTO 350
      ENDIF
      IF (I.EQ.(BANNUM+1)) THEN
          WRITE (*,*) 'ENTER NEW OUTPUT FILENAME : '
          READ  (*,'(A)') OUTFIL
      ELSE
          L=LAST(BNAM(I))
          WRITE (*,*) 'NEW FILENAMES FOR THE ',BNAM(I)(1:L),' BAND.'
          WRITE (*,*) 'ENTER ENERGY FILE NAME : '
          READ  (*,'(A)') ENFIL(I)
          WRITE (*,*) 'ENTER GRADIENT FILE NAME : '
          READ  (*,'(A)') GRFIL(I)
          WRITE (*,*) 'ENTER EIGENVECTOR FILE NAME : '
          READ  (*,'(A)') VEFIL(I)
      ENDIF
      GOTO 114
 
!     ALTER NAMES AND NUMBER OF BANDS 
116   WRITE (*,9945) '....ALTER NAMES AND NUMBER OF BANDS....'
      WRITE (*,*) 'YOU MAY :'
      WRITE (*,9915) (I,MENU2(I),I=1,4)
650   WRITE (*,9905) 'ENTER SELECTION (0=NONE):'
      READ  (*,*) I
      IF (I.EQ.0) GOTO 100
      GOTO (211,212,213,214) I
          WRITE(*,*) 'ILLEGAL CHOICE! TRY ONCE MORE'
          GOTO 650
 
   
211       WRITE (*,9905) 'YOU MAY RENAME :'
          WRITE (*,9915) (I,BNAM(I),I=1,BANNUM)
          WRITE (*,*) 'ENTER SELECTION (0=NONE):'
          READ  (*,*) I
          IF (I.EQ.0) GOTO 116
          IF (I.LT.1.OR.I.GT.BANNUM) THEN
              WRITE (*,9920) 'BAND NR.',I,'IS NOT DEFINED.'
              GOTO 211
          ENDIF
          WRITE (*,*) 'ENTER NEW NAME :'
          READ  (*,'(A)') BNAM(I)
          GOTO 116
 
212       IF (BANNUM.GE.MAXBAN) THEN
              WRITE (*,*) 'SORRY, MAXIMUM NUMBER OF BANDS IS REACHED'
              WRITE (*,9920) 'YOU CANNOT DEFINE MORE THAN',MAXBAN, &
                             'BANDS.'
          ELSE
              WRITE (*,*) 'ENTER NAME OF NEW BAND:'
              BANNUM=BANNUM+1
              READ  (*,'(A)') BNAM(BANNUM)
          ENDIF
          GOTO 116
 
213       IF (BANNUM.LE.0) THEN
              WRITE (*,*) 'YOU CAN''T HAVE LESS THAN ZERO BANDS'
          ELSE
              WRITE (*,9905) 'YOU MAY DISCARD :'
              WRITE (*,9915) (I,BNAM(I),I=1,BANNUM)
              WRITE (*,*) 'ENTER SELECTION (0=NONE) :'
              READ  (*,*) I
              IF (I.EQ.0) GOTO 116
              IF (I.LT.1.OR.I.GT.BANNUM) THEN
                  WRITE (*,9920) 'BAND NR.',I,'IS NOT DEFINED.'
                  GOTO 213
              ELSE
                  IF (I.EQ.INIT) INIT=0
                  IF (INIT.GT.I) INIT=INIT-1
                  IF (I.EQ.FINAL) FINAL=0
                  IF (FINAL.GT.I) FINAL=FINAL-1
                  IF (I.NE.BANNUM) THEN
                      DO J=I,BANNUM-1
                          BNAM(J)=BNAM(J+1)
                          ENFIL(J)=ENFIL(J+1)
                          GRFIL(J)=GRFIL(J+1)
                          VEFIL(J)=VEFIL(J+1)
                      END DO
                  ENDIF
                  ENFIL(BANNUM)=' '
                  GRFIL(BANNUM)=' '
                  VEFIL(BANNUM)=' '
                  BANNUM=BANNUM-1
              ENDIF
          ENDIF
          GOTO 116
 
214       WRITE(*,9905) 'THE BANDS DEFINED ARE: '
          WRITE (*,9915) (I,BNAM(I),I=1,BANNUM)
          GOTO 116

117   WRITE (*,*) ' '
      WRITE (*,*) '....SHOW ALL DATA....'
 
      IF (MECH.NE.0) THEN
          L=LAST(SCRNAM(MECH))
          WRITE (*,9905) 'THE CURRENT SCATTERING MECHANISM IS : '// &
                         SCRNAM(MECH)(1:L)
      ELSE
          WRITE (*,9905) 'NO SCATTERING MECHANISM IS DEFINED'
      ENDIF

      WRITE (*,9925) 'THE CURRENT TEMPERATURE IS ',T
 
      INITOK = INIT.GE.1.AND.INIT.LE.BANNUM
      IF (INITOK) THEN
          L=LAST(BNAM(INIT))
          WRITE (*,9910) 'INITIAL BAND :  THE ',BNAM(INIT)(1:L)//' BAND'
      ELSE
          WRITE (*,*) 'INITIAL BAND :  NOT DEFINED'
      ENDIF
 
      FINOK=FINAL.GE.1.AND.FINAL.LE.BANNUM
      IF (FINOK) THEN
          L=LAST(BNAM(FINAL))
          WRITE (*,9910) 'FINAL BAND   :  THE ',BNAM(FINAL)(1:L) &
                      //' BAND'
      ELSE
          WRITE (*,*) 'FINAL BAND   :  NOT DEFINED'
      ENDIF
 
      IF (BANNUM.EQ.0) THEN
          WRITE (*,*) 'NO BANDS ARE DEFINED'
      ELSE
          WRITE (*,*) 'THE FILENAMES ARE:'
          WRITE(*,9955) ' ','ENERGIES    ','GRADIENTS   ','EIGENVECTORS'
          DO I=1,BANNUM
              L=LAST(BNAM(I))
              WRITE (*,9955) BNAM(I)(1:L)//' BAND :',ENFIL(I), &
                             GRFIL(I),VEFIL(I)
          END DO
      ENDIF
 
      WRITE (*,*) 'THE OVERLAP INTEGRAL IS CALCULATED '//MENU3(OVMETH)

      IF (OUTFIL.EQ.' ') THEN
          WRITE (*,*) 'NO OUTPUT FILE IS DEFINED'
      ELSE
          WRITE (*,*) 'OUTPUT FILE : '//OUTFIL
      ENDIF

      WRITE (*,9905) 'PRESS RETURN TO CONTINUE'
      READ  (*,'(A)') DUMMY
      GOTO 100

!     SPECIFY HOW TO CALCULATE THE OVERLAP INTEGRAL
118   WRITE (*,9945) '....SPECIFY HOW TO CALCULATE THE '// &
                     'OVERLAP INTEGRAL....' 
      WRITE (*,9905) 'THERE ARE THREE ALTERNATIVES : '
      WRITE (*,9915) (I,MENU3(I),I=1,3)
750   WRITE (*,9905) 'ENTER SELECTION :'
      READ  (*,*) I
      IF (I.LT.1.OR.I.GT.3) THEN
          WRITE (*,*) 'ILLEGAL CHOICE! TRY ONCE MORE.'
          GOTO 750
      ENDIF
      OVMETH=I
      GOTO 100
 
 
!     SAVE AND EXIT 
115   WRITE (*,9945) '...SAVE AND EXIT...'
 
!     GIVE WARNING IF SCATTERING MECHANISM ISN'T SET
      IF (MECH.EQ.0) WRITE (*,9950) 'SCATTERING MECHANISM ISN''T SET'

!     CHECK THAT INITIAL AND FINAL BANDS ARE OK
      INITOK = INIT.GE.1.AND.INIT.LE.BANNUM
      FINOK=FINAL.GE.1.AND.FINAL.LE.BANNUM
      IF (.NOT.INITOK) WRITE(*,9950) 'INITIAL BAND IS NOT DEFINED'
      IF (.NOT.FINOK) WRITE(*,9950) 'FINAL BAND IS NOT DEFINED'
 
!     CHECK THAT FILENAMES ARE OK
      IF (INIT.NE.FINAL) THEN
          IF (INITOK.AND.ENFIL(INIT).EQ.' ') & 
              WRITE (*,9950) 'ENERGY FILE FOR INITIAL BAND IS NOT ' &
                       //'DEFINED' 
          IF (INITOK.AND.GRFIL(INIT).EQ.' ') &
              WRITE (*,9950) 'GRADIENT FILE FOR INITIAL BAND IS NOT ' &
                           //'DEFINED' 
          IF (INITOK.AND.VEFIL(INIT).EQ.' ') &
              WRITE (*,9950) 'EIGENVECTOR FILE FOR INITIAL BAND IS NOT ' &
                           //'DEFINED' 
          IF (FINOK.AND.ENFIL(FINAL).EQ.' ') &
              WRITE (*,9950) 'ENERGY FILE FOR FINAL BAND IS NOT ' &
                           //'DEFINED' 
          IF (FINOK.AND.GRFIL(FINAL).EQ.' ') &
              WRITE (*,9950) 'GRADIENT FILE FOR FINAL BAND IS NOT ' &
                           //'DEFINED' 
          IF (FINOK.AND.VEFIL(FINAL).EQ.' ') &
              WRITE (*,9950) 'EIGENVECTOR FILE FOR FINAL BAND IS NOT ' &
                           //'DEFINED' 
      ELSE 
          IF (INITOK.AND.ENFIL(INIT).EQ.' ') &
              WRITE (*,9950) 'ENERGY FILE FOR INITIAL AND FINAL ' &
                           //'BAND IS NOT DEFINED' 
          IF (INITOK.AND.GRFIL(INIT).EQ.' ') &
              WRITE (*,9950) 'GRADIENT FILE FOR INITIAL AND FINAL ' &
                           //'BAND IS NOT DEFINED' 
          IF (INITOK.AND.VEFIL(INIT).EQ.' ') &
              WRITE (*,9950) 'EIGENVECTOR FILE FOR INITIAL AND FINAL ' &
                           //'BAND IS NOT DEFINED' 
          ENDIF
 
      IF (OUTFIL.EQ.' ') WRITE (*,9950) 'NO OUTPUT FILE IS DEFINED'
 
      L=LAST(FNAME)
      WRITE (*,*) 'DATA SAVED ON FILE ',FNAME(1:L),''
      OPEN (10,FILE=FNAME,ACCESS='DIRECT',FORM='UNFORMATTED', &
            STATUS='OLD',RECL=LEN)
      WRITE (10,REC=1) BANNUM,BNAM,ENFIL,GRFIL,VEFIL,INIT,FINAL, &
                       OUTFIL,T,MECH,OVMETH
      CLOSE (10)
 
9900  FORMAT(' ',A,I3,' :')
9905  FORMAT(/,' ',A)
9910  FORMAT(' ',A,A)
9915  FORMAT(' ',I2,'. ',A) 
9920  FORMAT(' ',A,' ',I2,' ',A) 
9925  FORMAT(' ',A,F6.2,' K') 
9930  FORMAT(' ',A,A,A)
9935  FORMAT(' ',I2,'. ',A27,TR2,A,TR2,A,TR2,A)
9940  FORMAT(' ',TR4,A27,TR2,A,TR2,A,TR2,A,/)
9945  FORMAT(/,' ',A,/)
9950  FORMAT(' SCRINI WARNING : ',A)
9955  FORMAT(' ',TR4,A27,TR2,A,TR2,A,TR2,A)

      END
