      MODULE Halvorinit
      IMPLICIT NONE

      INTEGER, PARAMETER :: DBL = SELECTED_REAL_KIND(p=13)
!     DEFORMATION POTENTIAL AND VALENCE BAND PARAMETERS........
      REAL(KIND=DBL), PARAMETER :: A0     =  6.4844D-10   ! Lattice constant (m)
      REAL(KIND=DBL), PARAMETER :: AS     =  4.966789D-19 !
      REAL(KIND=DBL), PARAMETER :: BS     = -2.723723D-19 ! 
      REAL(KIND=DBL), PARAMETER :: DS     = -7.049636D-19 !
      REAL(KIND=DBL), PARAMETER :: A      =  0.98000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: B      = -0.65000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: D      =  0.70000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: DELTA0 =  1.520D-19    ! [J]
!     8X8-MODEL PARAMETERS........
      REAL(KIND=DBL), PARAMETER :: E0     = 4.245D-20     ! [J]
      REAL(KIND=DBL), PARAMETER :: P0     = 1.2816D-28    ! [JM]
!     14X14-MODEL PARAMETERS........
      REAL(KIND=DBL), PARAMETER :: E1     = 6.008D-19     ! [J]
      REAL(KIND=DBL), PARAMETER :: P1     = 1.0410D-28    ! [JM]
      REAL(KIND=DBL), PARAMETER :: Q      = 1.2335D-28    ! [JM]
      REAL(KIND=DBL), PARAMETER :: DELTA1 = 0.401D-19     ! [J]
      REAL(KIND=DBL), PARAMETER :: DELTAQ = 0.0D-19       ! [J]
      !REAL(KIND=DBL) :: DUMMY(3)
!     Mathematical parameters
      REAL(KIND=DBL), PARAMETER :: PI = 3.14159265358979

!     CORRECTION OPTIONS
      LOGICAL                   :: CORR   = .TRUE.        ! ADD CORRECTIONS

      REAL(KIND=DBL), PARAMETER :: LH1    =  0.17000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: LH2A   = -0.80000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: LH2B   =  0.40000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: LH2C   = -0.10000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: LH3A   =  6.00000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: LH3B   = -3.50000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: LH3C   =  0.22000      ! [HBAR**2/2M0]

      REAL(KIND=DBL), PARAMETER :: HH1    =  0.16000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: HH2A   =  0.40000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: HH2B   = -0.40000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: HH2C   = -0.05800      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: HH3A   = -4.00000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: HH3B   =  2.80000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: HH3C   =  0.14000      ! [HBAR**2/2M0]

      REAL(KIND=DBL), PARAMETER :: CB1A   = -0.15000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: CB1B   =  0.45000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: CB1C   =  0.00000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: CB2A   =  1.00000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: CB2B   =  1.00000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: CB2C   = -0.61000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: CB3A   =  6.00000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: CB3B   = -2.00000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: CB3C   = -1.20000      ! [HBAR**2/2M0]
      REAL(KIND=DBL), PARAMETER :: CB3D   =  0.75000      ! [HBAR**2/2M0]

!     Model size parameters.
      INTEGER, PARAMETER :: MS  = 14                     ! 
      INTEGER, PARAMETER :: MSH = 7                      !
      INTEGER, PARAMETER :: MSD = 28                     !

!     Strain parameters.
      REAL(KIND=DBL) :: EXX, EXY, EYY, EXZ, EYZ, EZZ

!     Logical parameters !!NB!! ARREYS ALWAYS MAX OF MSH!!!!!!!!!!
      LOGICAL :: ENCALC, GRCALC, VECALC, SDCALC, BANDSELECT(7), FINE

!     Mesh parameters
      INTEGER :: MESHNU, FMESHN
      REAL(KIND=DBL) :: BFRAC, FBFRAC

!     File name parameters !!NB!! ARREYS ALWAYS MAX OF MSH!!!!!!!!!!
      CHARACTER(LEN=12) :: ENNAME(7), GRNAME(7), VENAME(7), SDNAME(7)

!      EXX = 0.0; EXY = 0.0; EYY = 0.0; EXZ = 0.0; EYZ = 0.0; EZZ = 0.0
!      ENCALC = .TRUE.; GRCALC = .TRUE.; VECALC = .TRUE.; SDCALC = .FALSE.
!      BANDSELECT(1) = .FALSE.; BANDSELECT(2) = .TRUE.; BANDSELECT(3) = .TRUE.
!      FINE = .TRUE.
!      MESHNU = 32; FMESHN = 36
!      BFRAC = 0.24; FBFRAC = 0.06
      
      END MODULE Halvorinit

