!     PROGRAM FOR READING SCATTERING RATES FROM THE FILES PRODUCED BY
!     KPBAND2mkl.f AND SCRATES.f

      PROGRAM READRATES
      INTEGER, PARAMETER :: DBL = SELECTED_REAL_KIND(p=13)
      CHARACTER(LEN=12) :: NAVN1, NAVN2, NAVN3
      INTEGER :: N, FN, I, J, L, M
!     NMAX IS JUST FOR INITIALIZATION. MUST BE CHANGED IF YOU WANT LARGER MESH SIZES.      
      INTEGER, PARAMETER :: NMAX = 64
      INTEGER :: CRECORDS(NMAX), FRECORDS(NMAX)
      REAL(KIND=DBL) :: RATE, ENERGY, K, WAVMAX, FWAVMAX, MSIZE, FMSIZE
      LOGICAL :: SKIP 

      I=1
      J=1
      L=1
      M=1
      SKIP=.FALSE.      

      WRITE(*,*) 'Enter input energy filename (initial band):'
      READ(*,*) NAVN1
      WRITE(*,*) 'Enter input rates filename:'
      READ(*,*) NAVN2

      OPEN(10,FILE=NAVN2,ACCESS='DIRECT',RECL=8)
      READ(10,REC=1) N
      READ(10,REC=2) WAVMAX
      READ(10,REC=10+N**3+1) FN
      READ(10,REC=10+N**3+2) FWAVMAX
      CLOSE(10)
      WAVMAX = WAVMAX*1.0E-10
      FWAVMAX = FWAVMAX*1.0E-10
      WRITE(*,*) 'Enter output filename:'
      READ(*,*) NAVN3
      
      CALL PICKER(N,J,CRECORDS)
      CALL PICKER(FN,M,FRECORDS)

!     DISTANCE BETWEEN MESH POINTS.
      MSIZE = 2*WAVMAX/(J-1)
      FMSIZE = 2*FWAVMAX/(M-1)

      WRITE(*,*) 'NUMBER OF LINEAR MESHPOINTS (111), J, FOUND:'
      WRITE(*,*) J
      WRITE(*,*) 'NUMBER OF FINE MESHPOINTS:'
      WRITE(*,*) M
      WRITE(*,*) 'MAXIMUM WAVE VECTOR [10^10 1/m]:'
      WRITE(*,*) WAVMAX
      WRITE(*,*) 'MAXIMUM FINE MESH WAVE VECTOR [10^10 1/m]:'
      WRITE(*,*) FWAVMAX
      
!      PRINT *, 'RECORD NUMBERS', CRECORDS
!      PRINT *, 'FINE RECORD NUMBER', FRECORDS
      OPEN(10,FILE=NAVN1,ACCESS='DIRECT',RECL=8)
      OPEN(20,FILE=NAVN2,ACCESS='DIRECT',RECL=8)
      OPEN(30,FILE=NAVN3)

!     THIS SECTION MERGES THE COARSE AND FINE MESHES.
300   IF (-WAVMAX+MSIZE*(I-1).LE.WAVMAX) THEN
!     SKIP OVER THE COARSE MESH POINTS NEAR k = 0.
          IF (SKIP) THEN
              I=I+CEILING((J-1)*FWAVMAX/WAVMAX)
              SKIP=.FALSE.
          ENDIF
!     THIS IF CONDITION CHECKS IF YOU ARE IN THE COARSE OR FINE MESH,
!     AND WRITES THE CORRESPONDING ENERGY/K-VALUE TO FILE.
          IF (-WAVMAX+MSIZE*(I-1).LT.(-FWAVMAX).OR. &
              -FWAVMAX+FMSIZE*(L-1).GT.FWAVMAX) THEN
              READ(10,REC=CRECORDS(I)) ENERGY
              READ(20,REC=CRECORDS(I)) RATE
              K=-WAVMAX+MSIZE*(I-1)
!     THE RATES ARE SYMMETRIC, SO WE ONLY STORE FOR K >= 0.
              IF (K.GE.0.0) THEN
                  WRITE(30,220) ENERGY, RATE
              ENDIF
              I=I+1
          ELSE
              READ(10,REC=(10+J**3+FRECORDS(L))) ENERGY
              READ(20,REC=(10+J**3+FRECORDS(L))) RATE
              K=-FWAVMAX+FMSIZE*(L-1)
              IF (K.GE.0.0) THEN
                  WRITE(30,220) ENERGY, RATE
              ENDIF
              L=L+1
!     IF YOU ARE IN THE FINE MESH, AND THE NEXT MESH POINT IS
!     OUTSIDE OF THE FINE MESH, THIS SAYS THAT IT IS TIME TO SKIP
!     THE COARSE MESH POINTS LOCATED INSIDE THE FINE MESH.
              IF (-FWAVMAX+FMSIZE*(L-1).GT.FWAVMAX) THEN
                  SKIP=.TRUE.
              ENDIF
          ENDIF
          GOTO 300
      ENDIF
      
220   FORMAT(E9.3,' ',E9.3)
230   FORMAT(E9.3,' ',E9.3,' ',E9.3)
      CLOSE(10)
      CLOSE(20)
      CLOSE(30)
      STOP
      END
      
      SUBROUTINE PICKER(MESHNU,J,SICK)
      
      INTEGER :: X,Y,Z,I,J,MESHNU
      INTEGER, PARAMETER :: NMAX = 64
      INTEGER :: SICK(NMAX)
      
      I=10
      J=0
      DO Z=0,MESHNU-1
         DO Y=0,MESHNU-1
            DO X=0,MESHNU-1
               I=I+1
               IF ((X.EQ.Y).AND.(Y.EQ.Z)) THEN
!              ALONG THE (111) DIRECTION
                  J=J+1  
                  SICK(J)=I
               ENDIF
            END DO
         END DO
      END DO
      RETURN
      END
