CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  THIS IS THE SUBPROGRAMS USED IN THE MC-AVERAGING
C 
C  THE SUBROUTINE "CORREC" SHOULD REPLACE THE CORRESPONDING SUBROUTINE
C  IN SCRATES
C 
C  THE SUBROUTINE MCMID SHOULD BE USED INSTEAD OF MATEL FOR
C  SMALL Q SCATTERING
C 
C  THE VARIABLE DK IN THE MAIN PROGRAM MUST DELARED TO FIT THE USE HERE
C 
C  THE MONTE CARLO AVERAGING  SUBROUTINE MCMID  USES A NAG LIBRARY
C  SUBROUTINE FOR THE RANDOM NUMBER GENERATION
C 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC 
 
C     THIS SUBROUTINE CALCULATES THE VECTOR FROM THE CENTRE OF THE
C     CUBE TO THE MIDDLE-POINT OF THE CROSSSECTION PLANE AT THE 
C     DISTANT W FROM THE CENTRE OF THE CUBE. C CONTAINS THE PLANE
C     NORMAL, AND B IS HALF THE SIDE LENGTH OF THE CUBE. THE SORTED
C     MAGNITUDES OF THE DIRECTION COSINES IN C IS RETURNED IN L.
C     THE VECTOR IS RETURNED IN DK. 
 
      SUBROUTINE CORREC(C,W,B,L1,L2,L3,DK,NP)
      REAL C(3),L(3),W,B,DK(3,7),L1,L2,L3,M(3,7)
      INTEGER TI,I,J,INV(3),NP
      REAL TR,W1,W2,W3,W4,S(3)
 
C     FIRST THE TRANSFORMATION INTO VALID VALUES OF THE DIRECTION 
C     COSINES ARE DONE (THESE ARE HELD IN L).
      DO 10 I=1,3
          IF (C(I).GE.0) THEN 
              S(I)=1
          ELSE    
              S(I)=-1
          ENDIF
          L(I)=ABS(C(I))
          INV(I)=I
10    CONTINUE
      DO 20 J=2,1,-1
      DO 20 I=1,J
          IF (L(I+1).GT.L(I)) THEN
              TR=L(I)
              TI=INV(I)
              L(I)=L(I+1)
              INV(I)=INV(I+1)
              L(I+1)=TR
              INV(I+1)=TI
          ENDIF
20    CONTINUE
      L1=L(1)
      L2=L(2)
      L3=L(3)

C     HERE THE DISTANCES BETWEEN THE FOUR CORNERS OF THE CUBE AND 
C     THE PLANE CROSSING THROUGH THE CENTRE ARE COMPUTED
      W1 = B*ABS(L(1)-L(2)-L(3))
      W2 = B*(L(1)-L(2)+L(3))
      W3 = B*(L(1)+L(2)-L(3))
      W4 = B*(L(1)+L(2)+L(3))
 
C     HERE THE VECTOR IS COMPUTED
      IF (W .LE. W1) THEN
          IF (L1 .GE. L2+L3) THEN
              NP=5
              M(1,NP)=W/L(1)
              M(2,NP)=0
              M(3,NP)=0
 
              M(1,1) = (W+B*(L(2)+L(3)))/L(1)
              M(2,1) = -B
              M(3,1) = -B
 
              M(1,4) = (W+B*(L(2)-L(3)))/L(1)
              M(2,4) = -B
              M(3,4) =  B
 
              M(1,2) = (W+B*(-L(2)+L(3)))/L(1)
              M(2,2) =  B
              M(3,2) = -B
 
              M(1,3) = (W-B*(L(2)+L(3)))/L(1)
              M(2,3) = B
              M(3,3) = B
 
          ELSE
              NP=7 
              M(1,NP)=W/(3*L(1))
              M(2,NP)=W/(3*L(2))
              M(3,NP)=W/(3*L(3))
 
              M(1,1) = (W+B*(L(2)-L(3)))/L(1)
              M(2,1) = -B
              M(3,1) =  B
 
              M(1,4) = (W+B*(-L(2)+L(3)))/L(1)
              M(2,4) =  B
              M(3,4) = -B
 
              M(1,6) = -B
              M(2,6) = (W+B*(L(1)-L(3)))/L(2)
              M(3,6) =  B

              M(1,3) =  B
              M(2,3) = (W-B*(L(1)-L(3)))/L(2)
              M(3,3) = -B
 
              M(1,5) = -B
              M(2,5) =  B
              M(3,5) = (W+B*(L(1)-L(2)))/L(3)
 
              M(1,2) =  B
              M(2,2) = -B
              M(3,2) = (W-B*(L(1)-L(2)))/L(3)

          ENDIF
      ELSEIF (W .LE. W2) THEN
          NP=6
          M(1,NP)=(3*W+B*(2*L(1)-L(2)-L(3)))/(5*L(1))
          M(2,NP)=(W-B*(L(1)-L(3)))/(5*L(2))
          M(3,NP)=(W-B*(L(1)-L(2)))/(5*L(3))
 
          M(1,1) = (W+B*(L(2)-L(3)))/L(1)
          M(2,1) = -B
          M(3,1) =  B
 
          M(1,4) = (W+B*(-L(2)+L(3)))/L(1)
          M(2,4) =  B
          M(3,4) = -B
 
          M(1,5) = (W-B*(L(2)+L(3)))/L(1)
          M(2,5) = B
          M(3,5) = B
 
          M(1,3) =  B
          M(2,3) = (W-B*(L(1)-L(3)))/L(2)
          M(3,3) = -B
 
          M(1,2) =  B
          M(2,2) = -B
          M(3,2) = (W-B*(L(1)-L(2)))/L(3)
 
      ELSEIF (W .LE. W3) THEN
          NP=5
          M(1,NP)=(W+B*(L(1)-L(2)))/(L(1)*2)
          M(2,NP)=(W+B*(L(2)-L(1)))/(L(2)*2)
          M(3,NP)=0
 
          M(1,1) = (W+B*(-L(2)+L(3)))/L(1)
          M(2,1) =  B
          M(3,1) = -B
 
          M(1,2) = (W-B*(L(2)+L(3)))/L(1)
          M(2,2) = B
          M(3,2) = B
 
          M(1,4) =  B
          M(2,4) = (W-B*(L(1)-L(3)))/L(2)
          M(3,4) = -B
 
          M(1,3) =  B
          M(2,3) = (W-B*(L(1)+L(3)))/L(2)
          M(3,3) =  B

      ELSEIF (W .LE. W4) THEN
          NP=4
          M(1,NP)=(W+B*(2*L(1)-L(2)-L(3)))/(3*L(1))
          M(2,NP)=(W+B*(2*L(2)-L(1)-L(3)))/(3*L(2))
          M(3,NP)=(W+B*(2*L(3)-L(1)-L(2)))/(3*L(3))
 
          M(1,1) = (W-B*(L(2)+L(3)))/L(1)
          M(2,1) = B
          M(3,1) = B

          M(1,2) = B
          M(2,2) = (W-B*(L(1)+L(3)))/L(2)
          M(3,2) = B
 
          M(1,3) = B
          M(2,3) = B
          M(3,3) = (W-B*(L(1)+L(2)))/L(3)
 
      ELSE
         WRITE (*,*) 'PLANE OUTSIDE CUBE!'
         STOP
      ENDIF
 
C     THEN THE VECTOR IS TRANSFORMED BACK INTO THE ORIGINAL SYSTEM OF
C     COORDINATES
      DO 30 J=1,NP
      DO 30 I=1,3
          DK(INV(I),J)=M(I,J)*S(INV(I))
30    CONTINUE

      END
 
 
 
      FUNCTION MCMID(MECH,C,W,B,KXI,KYI,KZI,KXF,KYF,KZF)
      REAL C(3),W,B,KXI,KYI,KZI,KXF,KYF,KZF,MCMID
      DOUBLE PRECISION X,Y,R,G05CAF
      INTEGER I,NP,A,J,K,P1,P2,MECH 
      REAL L1,L2,L3,DK(3,7),L,F(3),ACW(0:6)
      REAL V,TH,V1,V2,Q
      REAL MATEL

      EXTERNAL G05CAF

      MCMID=0

      CALL CORREC(C,W,B,L1,L2,L3,DK,NP)
 
      DO 40 I=1,NP-1
      DO 40 J=1,3 
          DK(J,I)=DK(J,I)-DK(J,NP)
40    CONTINUE
      KXF=KXF+DK(1,NP)
      KYF=KYF+DK(2,NP)
      KZF=KZF+DK(3,NP)
 
      ACW(0)=0
      DO 45 I=1,NP-1
          P1=I
          P2=1+MOD(P1,NP-1)
          L=SQRT(DK(1,P1)**2+DK(2,P1)**2+DK(3,P1)**2)
          L=L*SQRT(DK(1,P2)**2+DK(2,P2)**2+DK(3,P2)**2)
          V=DK(1,P1)*DK(1,P2)+DK(2,P1)*DK(2,P2)+DK(3,P1)*DK(3,P2)
          V=V/L
          ACW(I)=ACW(I-1)+0.5*L*SQRT(ABS(1-V**2))
45    CONTINUE
 
      DO 46 I=1,NP-1
          ACW(I)=ACW(I)/ACW(NP-1)
46    CONTINUE

 
C     START OF MONTE CARLO ANALYSIS

      DO 10 I=1,500
 
          A=1
          X=G05CAF(R)
11        IF (.NOT.(X.GE.ACW(A-1).AND.X.LE.ACW(A))) THEN
              A=A+1
              GOTO 11
          ENDIF

          X=G05CAF(R)
          Y=SQRT(G05CAF(R))
          P1=A
          P2=1+MOD(A,NP-1)
          V1=SQRT(DK(1,P1)**2+DK(2,P1)**2+DK(3,P1)**2)
          V2=SQRT(DK(1,P2)**2+DK(2,P2)**2+DK(3,P2)**2)
          TH=DK(1,P1)*DK(1,P2)+DK(2,P1)*DK(2,P2)+DK(3,P1)*DK(3,P2)
          TH=ABS(TH/(V1*V2))
          TH=ACOS(TH)
          V1=V1*SIN(X*TH)
          V2=V2*SIN((1-X)*TH)
          X=V1/(V1+V2)
          DO 50 J=1,3
              F(J)=Y*(X*DK(J,P1)+(1-X)*DK(J,P2))
50        CONTINUE
          Q=SQRT((KXI-KXF-F(1))**2+(KYI-KYF-F(2))**2+(KZI-KZF-F(3))**2)
          MCMID=MCMID+MATEL(Q,MECH)

10    CONTINUE
 
1000      MCMID=MCMID/500

 
      END
